#!/bin/sh

# Fixes (what I consider) a bug in the way TeX4ht handles seealso
# index entries.

if [ $# -lt 1 ]; then
    echo Usage: fixTeXfht_index_bug.sh \<index_input_file\> >&2
    exit 1
fi

TMPFILE=`mktemp /tmp/index.XXXXXX` 
if [ -z "$TMPFILE" ]; then
    echo ***BUGFIX FAILED: $0 >&2
    echo ***mktemp failed to create a temporary file >&2
    exit 1
fi


# This is rather painful to look at.
#
# It's basically finding index entries with 'see' or 'seealso'
# clauses, and removing the erroneous LNK clauses at the end
sed -e 's/^\(\\indexentry[:space:]*{.*|[:space:]*see\(also\)\?[:space:]*{.*}\)[:space:]*|[:space:]*LNK\([:space:]*{.*}\)\{3\}\(}[:space:]*{.*}\)[:space:]*$/\1\4/g' < $1 > $TMPFILE

cp $TMPFILE $1
rm $TMPFILE
